// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from Status.djinni

#pragma once

#include <cstdint>
#include <string>
#include <utility>

namespace verifone_sdk {

struct CommerceConstants final {

    /** The default mode. Use when communicating with an actual device. */
    static std::string const MODE_DEVICE;

    /**
     * Uses pre-built responses without connecting to an actual device. 
     * This allows automated tests and simplified flows. 
     */
    static std::string const MODE_STUB;

    /** Use when communicating with a terminal emulator. */
    static std::string const MODE_EMULATOR;

    /**
     * The status code when an action has been canceled, generally by sending an abort command, or
     * in the case of user input, canceling the input screen.
     */
    static constexpr int32_t STATUS_CANCELED = 1000;

    /** Sent when the connection to the device has been lost and cannot be restored. */
    static constexpr int32_t STATUS_CONNECTION_FAILED = 2000;

    /**
     * To be used in the Application Manifest to hold the CP App Id, so that messages can be
     * communicated between the terminal and this app. Example:
     * {@code
     * <manifest xmlns:android="http://schemas.android.com/apk/res/android" ...>
     *     <application ...>
     *         <meta-data android:name="com.verifone.commerce.manifest.appid" android:value="[cp app id]" />
     * }
     */
    static std::string const CP_APP_ID_META_DATA_NAME;

    /**
     * Puts the service in a debug mode that returns fixed responses without communicating with
     * the terminal when used with
     * {@link com.verifone.commerce.payment.TransactionManager#setDebugMode(int)}.
     */
    static constexpr int32_t MODE_STUBS_DEBUG = 1;

    /**
     * Tells the service to communicate with a terminal simulator that returns fixed responses
     * when used with {@link com.verifone.commerce.payment.TransactionManager#setDebugMode(int)}.
     */
    static constexpr int32_t MODE_SIMULATOR = 2;

    /**
     * The proper constant to communicate with a physical terminal when used with
     * {@link com.verifone.commerce.payment.TransactionManager#setDebugMode(int)}.
     * const MODE_DEVICE: i32 = 3;
     */
    static constexpr int32_t INSUFFICIENT_PERMISSIONS = -1;
};

}  // namespace verifone_sdk
