// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from Merchant.djinni

#pragma once

#include "Acquirer.hpp"
#include "Decimal.hpp"
#include <optional>
#include <string>
#include <utility>
#include <vector>

namespace verifone_sdk {

struct Merchant; // Requiring extended class

/** Represents a merchant. */
struct MerchantBase {

    /** name of the merchant */
    static std::string const MERCHANT_NAME_COLUMN;

    /** address of the merchant */
    static std::string const MERCHANT_ADDRESS_COLUMN;
    /** record id of the merchant */
    std::optional<std::string> recordId;
    /** The name of the merchant as set by the merchant. */
    std::optional<std::string> merchantName;
    /** The address of the merchant */
    std::optional<std::string> merchantAddress;
    /** The ISO 3166-1 country code where the merchant is operating */
    std::optional<std::string> countryCode;
    /** The ISO18245 category code for the merchant */
    std::optional<std::string> merchantCategoryCode;
    /** If this merchant is the primary merchant on the POI */
    std::optional<bool> isPrimaryFlag;
    /** Balance Enquiry Enabled */
    std::optional<bool> isBalanceEnquiry;
    /** Cashout Ceiling */
    std::optional<Decimal> cashoutCeiling;
    /** is cash out only enabled */
    std::optional<bool> isCashoutOnlyEnabled;
    /** is Force offline Enabled */
    std::optional<bool> isForceOfflineEnabled;
    /** is Manual Pre auth enabled */
    std::optional<bool> isManualPreAuthEnabled;
    /** is Manual Purchase Enabled */
    std::optional<bool> isManualPurchaseEnabled;
    /** is Manual Refund Enabled */
    std::optional<bool> isManualRefundEnabled;
    /** maximum purchase Amount */
    std::optional<Decimal> maxPurchaseAmount;
    /** isMotoPaymentEnabled */
    std::optional<bool> isMotoPaymentEnabled;
    /** isMotoRefundEnabled */
    std::optional<bool> isMotoRefundEnabled;
    /** phone number */
    std::optional<std::string> phoneNumber;
    /** is Pre Auth Enabled */
    std::optional<bool> isPreAuthEnabled;
    /** is Purchase And Cash out Enabled */
    std::optional<bool> isPurchaseAndCashoutEnabled;
    /** is Purchase Enabled */
    std::optional<bool> isPurchaseEnabled;
    /** is Refund Enabled */
    std::optional<bool> isRefundEnabled;
    /** is Tip PRompt Enabled */
    std::optional<bool> isTipPromptEnabled;
    /** is Void Enabled */
    std::optional<bool> isVoidEnabled;
    /** An array of PaymentAcquirerData objects without payment information */
    std::vector<Acquirer> acquirers;

    MerchantBase(std::optional<std::string> recordId_,
                 std::optional<std::string> merchantName_,
                 std::optional<std::string> merchantAddress_,
                 std::optional<std::string> countryCode_,
                 std::optional<std::string> merchantCategoryCode_,
                 std::optional<bool> isPrimaryFlag_,
                 std::optional<bool> isBalanceEnquiry_,
                 std::optional<Decimal> cashoutCeiling_,
                 std::optional<bool> isCashoutOnlyEnabled_,
                 std::optional<bool> isForceOfflineEnabled_,
                 std::optional<bool> isManualPreAuthEnabled_,
                 std::optional<bool> isManualPurchaseEnabled_,
                 std::optional<bool> isManualRefundEnabled_,
                 std::optional<Decimal> maxPurchaseAmount_,
                 std::optional<bool> isMotoPaymentEnabled_,
                 std::optional<bool> isMotoRefundEnabled_,
                 std::optional<std::string> phoneNumber_,
                 std::optional<bool> isPreAuthEnabled_,
                 std::optional<bool> isPurchaseAndCashoutEnabled_,
                 std::optional<bool> isPurchaseEnabled_,
                 std::optional<bool> isRefundEnabled_,
                 std::optional<bool> isTipPromptEnabled_,
                 std::optional<bool> isVoidEnabled_,
                 std::vector<Acquirer> acquirers_)
    : recordId(std::move(recordId_))
    , merchantName(std::move(merchantName_))
    , merchantAddress(std::move(merchantAddress_))
    , countryCode(std::move(countryCode_))
    , merchantCategoryCode(std::move(merchantCategoryCode_))
    , isPrimaryFlag(std::move(isPrimaryFlag_))
    , isBalanceEnquiry(std::move(isBalanceEnquiry_))
    , cashoutCeiling(std::move(cashoutCeiling_))
    , isCashoutOnlyEnabled(std::move(isCashoutOnlyEnabled_))
    , isForceOfflineEnabled(std::move(isForceOfflineEnabled_))
    , isManualPreAuthEnabled(std::move(isManualPreAuthEnabled_))
    , isManualPurchaseEnabled(std::move(isManualPurchaseEnabled_))
    , isManualRefundEnabled(std::move(isManualRefundEnabled_))
    , maxPurchaseAmount(std::move(maxPurchaseAmount_))
    , isMotoPaymentEnabled(std::move(isMotoPaymentEnabled_))
    , isMotoRefundEnabled(std::move(isMotoRefundEnabled_))
    , phoneNumber(std::move(phoneNumber_))
    , isPreAuthEnabled(std::move(isPreAuthEnabled_))
    , isPurchaseAndCashoutEnabled(std::move(isPurchaseAndCashoutEnabled_))
    , isPurchaseEnabled(std::move(isPurchaseEnabled_))
    , isRefundEnabled(std::move(isRefundEnabled_))
    , isTipPromptEnabled(std::move(isTipPromptEnabled_))
    , isVoidEnabled(std::move(isVoidEnabled_))
    , acquirers(std::move(acquirers_))
    {}

    virtual ~MerchantBase() = default;

protected:
    MerchantBase(const MerchantBase&) = default;
    MerchantBase(MerchantBase&&) = default;
    MerchantBase& operator=(const MerchantBase&) = default;
    MerchantBase& operator=(MerchantBase&&) = default;
};

}  // namespace verifone_sdk
